﻿using System;
using System.ComponentModel.DataAnnotations;
using System.Linq;

namespace DataAccess.Class
{
    public class CustomRange : ValidationAttribute
    {
        public CustomRange(string[] values)
        {
            Values = values;
        }

        public string[] Values { get; }

        protected override ValidationResult IsValid(object value, ValidationContext validationContext)
        {
            return !Values.Contains(Convert.ToString(value)) ? new ValidationResult(FormatErrorMessage(validationContext.DisplayName)) : null;
        }
    }
}
