﻿using System.Collections.Generic;
using DataAccess.Model;
using NHibernate.Criterion;

namespace DataAccess.Dao
{
    public class AnswerDao : DaoBase<Answer>
    {
        public IList<Answer> GetByQuestion(Question question)
        {
            return Session.CreateCriteria<Answer>()
                .Add(Restrictions.Eq("Question", question))
                .List<Answer>();
        }

        public IList<Answer> GetByQuestionAndType(Question question, int type)
        {
            return Session.CreateCriteria<Answer>()
               .Add(Restrictions.Eq("Question", question)).Add(Restrictions.Eq("Type", type))
               .List<Answer>();
        }

        public IList<Answer> GetByQuestionsOfTestsAndType(QuestionsOfTest questionsOfTest, int type)
        {
            return Session.CreateCriteria<Answer>()
               .Add(Restrictions.Eq("QuestionsOfTest", questionsOfTest)).Add(Restrictions.Eq("Type", type))
               .List<Answer>();
        }
    }
}
