﻿using System.Collections.Generic;
using DataAccess.Model;
using NHibernate.Criterion;

namespace DataAccess.Dao
{
    public class ArticleDao : DaoBase<Article>
    {
        public IList<Article> GetArticlesPaged(int count, int page, out int totalItems)
        {

            totalItems = Session.CreateCriteria<Article>() // vytvoreni kriteria
                .SetProjection(Projections.RowCount()) // spocitani poctu radku
                .UniqueResult<int>(); //vraceni unikatniho vysledku

            return Session.CreateCriteria<Article>()
                .AddOrder(Order.Desc("AddedDate"))
                .SetFirstResult((page - 1)*count)
                .SetMaxResults(count).List<Article>();
        }

        public IList<Article> GetByUser(User user)
        {
            return Session.CreateCriteria<Article>()
                .Add(Restrictions.Eq("User", user))
                .List<Article>();
        }

        public IList<Article> SearchArticles(string phrase)
        {
            return Session.CreateCriteria<Article>().Add(Restrictions.Like("Title", $"%{phrase}%"))
                .List<Article>();
        }
    }
}