﻿using System.Collections.Generic;
using DataAccess.Model;
using NHibernate.Criterion;

namespace DataAccess.Dao
{
    public class ChapterDao : DaoBase<Chapter>
    {
        public IList<Chapter> GetChaptersPaged(int count, int page, out int totalItems)
        {
            totalItems = Session.CreateCriteria<Chapter>() // vytvoreni kriteria
                .SetProjection(Projections.RowCount()) // spocitani poctu radku
                .UniqueResult<int>(); //vraceni unikatniho vysledku

            return Session.CreateCriteria<Chapter>()
                .AddOrder(Order.Asc("Id"))
                .SetFirstResult((page - 1) * count)
                .SetMaxResults(count).List<Chapter>();
        }

        public IList<Chapter> SearchChapters(string phrase)
        {
            return Session.CreateCriteria<Chapter>().Add(Restrictions.Like("Name", $"%{phrase}%"))
                .List<Chapter>();
        }

        public string GetAllKeywords()
        {
            IList<Chapter> chapters = Session.QueryOver<Chapter>().List<Chapter>();

            string keywords = "";

            foreach (Chapter chapter in chapters)
            {
               keywords += chapter.Keywords;

                keywords += ", ";
            }

            return keywords;
        }
    }
}