﻿using System.Collections.Generic;
using DataAccess.Model;
using NHibernate.Criterion;

namespace DataAccess.Dao
{
    public class QuestionDao : DaoBase<Question>
    {
        public IList<Question> GetQuestionsPaged(int count, int page, out int totalItems)
        {
            totalItems = Session.CreateCriteria<Question>() // vytvoreni kriteria
                .SetProjection(Projections.RowCount()) // spocitani poctu radku
                .UniqueResult<int>(); //vraceni unikatniho vysledku

            return Session.CreateCriteria<Question>()
                .AddOrder(Order.Asc("Id"))
                .SetFirstResult((page - 1) * count)
                .SetMaxResults(count).List<Question>();
        }

        public IList<Question> GetByChapter(Chapter chapter)
        {
            return Session.CreateCriteria<Question>()
                .Add(Restrictions.Eq("Chapter", chapter))
                .List<Question>();
        }

        public IList<Question> SearchQuestions(string phrase)
        {
            return Session.CreateCriteria<Question>().CreateAlias("Chapter", "chap").Add(Restrictions.Like("chap.Name", $"%{phrase}%"))
                .List<Question>();
        }
    }
}
