﻿using System.Collections.Generic;
using DataAccess.Model;
using NHibernate.Criterion;

namespace DataAccess.Dao
{
    public class QuestionsOfTestDao : DaoBase<QuestionsOfTest>
    {
        public IList<QuestionsOfTest> GetQuestionsOfTestsPaged(int count, int page, out int totalItems)
        {
            totalItems = Session.CreateCriteria<QuestionsOfTest>() // vytvoreni kriteria
                .SetProjection(Projections.RowCount()) // spocitani poctu radku
                .UniqueResult<int>(); //vraceni unikatniho vysledku

            return Session.CreateCriteria<QuestionsOfTest>()
                .AddOrder(Order.Asc("Number"))
                .SetFirstResult((page - 1) * count)
                .SetMaxResults(count).List<QuestionsOfTest>();
        }

        public IList<QuestionsOfTest> GetByQuestion(Question question)
        {
            return Session.CreateCriteria<QuestionsOfTest>()
                 .Add(Restrictions.Eq("Question", question))
                 .List<QuestionsOfTest>();
        }
        public IList<QuestionsOfTest> GetByTest(Test test)
        {
            return Session.CreateCriteria<QuestionsOfTest>()
                 .Add(Restrictions.Eq("Test", test))
                 .List<QuestionsOfTest>();
        }

        public QuestionsOfTest GetByNumberAndTest(Test test, int number)
        {

            return Session.CreateCriteria<QuestionsOfTest>()
                 .Add(Restrictions.Eq("Test", test)).Add(Restrictions.Eq("Number", number))
                 .UniqueResult<QuestionsOfTest>();
        }
    }
}
