﻿using System;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using DataAccess.Interface;

namespace DataAccess.Model
{
    public class Article : IEntity
    {
        public virtual int Id { get; set; }

        [Required(ErrorMessage = "Titulek článku je vyžadován!")]
        public virtual string Title { get; set; }

        [Required(ErrorMessage = "Text článku je vyžadován!")]
        [AllowHtml]
        public virtual string Text { get; set; }

        [Required(ErrorMessage = "Datum přidání článku je vyžadován!")]
        public virtual DateTime AddedDate { get; set; }

        public virtual User User { get; set; }
    }
}
