﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using DataAccess.Interface;
using System.Web.Mvc;
using DataAccess.Dao;

namespace DataAccess.Model
{
    public class Chapter : IEntity
    {
        public virtual int Id { get; set; }

        [Required(ErrorMessage = "Zadejte název Kapitoly!")]
        public virtual string Name { get; set; }

        [Required(ErrorMessage = "Zadejte klíčová slova pro Kapitolu!")]
        public virtual string Keywords { get; set; }

        public virtual string Description { get; set; }

        [Required(ErrorMessage = "Zadejte obsah Kapitoly!")]
        [AllowHtml]
        public virtual string ChapterContent { get; set; }

        public virtual string Presentation { get; set; }

        [Required(ErrorMessage = "Zadejte počet otázek testu Kapitoly!")]
        public virtual int NumberOfQuestions { get; set; }

        [NotMapped]
        public virtual int ActualQuestions
        {
            get
            {
                IList<Question> questions = new QuestionDao().GetByChapter(new ChapterDao().GetById(Id));

                return questions.Count;
            }
        }

        [NotMapped]
        public virtual bool Enought
        {
            get
            {
                IList<Question> questions = new QuestionDao().GetByChapter(new ChapterDao().GetById(Id));

                return questions.Count >= NumberOfQuestions;
            }
        }
    }
}
