﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using DataAccess.Class;
using DataAccess.Interface;

namespace DataAccess.Model
{
    public class Question : IEntity
    {
        public virtual int Id { get; set; }

        [Required(ErrorMessage = "Otázka je vyžadována!")]
        public virtual string Task { get; set; }

        [Required(ErrorMessage = "Typ otázky je vyžadován!")]
        [CustomRange(new[] { "Zaškrtávací", "Doplňovací" }, ErrorMessage = "Zadejte typ otázky ze seznamu!")]
        public virtual string Type { get; set; }

        public virtual string A { get; set; }

        public virtual string B { get; set; }

        public virtual string C { get; set; }

        public virtual string D { get; set; }

        public virtual Chapter Chapter { get; set; }

        public virtual IList<QuestionsOfTest> Tests { get; set; }

    }
}
