﻿using System;
using System.IO;
using NHibernate;
using NHibernate.Cfg;

namespace DataAccess
{
    public class NHibernateHelper
    {
        private static ISessionFactory _factory;

        public static ISession Session
        {
            get
            {
                if (_factory != null) return _factory.OpenSession();
                var cfg = new Configuration();
                _factory =
                    cfg.Configure(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "Hibernate.cfg.xml"))
                        .BuildSessionFactory();
                return _factory.OpenSession();
            }
        }
    }
}