﻿using System;
using System.Web.Mvc;
using DataAccess.Dao;

namespace PRIPO_v02.Areas.Admin.Controllers
{
    [ChildActionOnly]
    [Authorize(Roles = "admin")]
    public class PageController : Controller
    {
        // GET: Admin/Page
        public ActionResult Index(int? page, int itemsOnPage, string controler, string view, int? id, string order)
        {
            int pg = page ?? 1;
            
            ViewBag.Pages = (int)Math.Ceiling((double)CheckControler(controler, id) / itemsOnPage);
            // vrati v celych cislech zaokrouhluje nahoru

            ViewBag.CurrentPage = pg;

            ViewBag.Id = id;

            ViewBag.View = view;

            ViewBag.Order = order;

            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }

            return View();
        }

        private int CheckControler(string controler, int? id)
        {
            int totalItems = 0;

            switch (controler)
            {
                case "User":
                    totalItems = new UserDao().GetAll().Count;
                    break;
                case "Article":
                    totalItems = new ArticleDao().GetAll().Count;
                    break;
                case "Chapter":
                    totalItems = new ChapterDao().GetAll().Count;
                    break;
                case "Question":
                    totalItems = new QuestionDao().GetAll().Count;
                    break;
                case "Test":
                    totalItems = id != null ? new TestDao().GetByUser(new UserDao().GetById((int)id)).Count : new TestDao().GetAll().Count;
                    break;
            }
            ViewBag.Controler = controler;

            return totalItems;
        }
    }
}