﻿using System.Collections.Generic;
using System.Web.Mvc;
using DataAccess.Dao;
using DataAccess.Model;

namespace PRIPO_v02.Areas.Student.Controllers
{
    [Authorize]
    public class ArticleController : Controller
    {
        [ChildActionOnly]
        // GET: Student/Article
        public ActionResult Index(int? page)
        {
            const int itemsOnPage = 10;
            int pg = page ?? 1;
            int totalItems;

            ViewBag.CurrentPage = pg;
            ViewBag.ItemsOnPage = itemsOnPage;

            IList<Article> articles = new ArticleDao().GetArticlesPaged(itemsOnPage, pg, out totalItems);

            if (Request.IsAjaxRequest())
            {
                return PartialView(articles);
            }

            return View(articles);
        }
    }
}