﻿using System;
using System.Web.Mvc;
using DataAccess.Dao;

namespace PRIPO_v02.Areas.Student.Controllers
{
    [ChildActionOnly]
    [Authorize]
    public class PageController : Controller
    {
        // GET: Student/Page
        public ActionResult Index(int? page, int itemsOnPage, string controler, string view, string order)
        {
            int pg = page ?? 1;

            ViewBag.Pages = (int)Math.Ceiling((double)CheckControler(controler) / itemsOnPage);
            // vrati v celych cislech zaokrouhluje nahoru

            ViewBag.CurrentPage = pg;

            ViewBag.View = view;

            ViewBag.Order = order;

            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }

            return View();
        }

        private int CheckControler(string controler)
        {
            int totalItems = 0;

            switch (controler)
            {
                case "Article":
                    totalItems = new ArticleDao().GetAll().Count;
                    break;
                case "Chapter":
                    totalItems = new ChapterDao().GetAll().Count;
                    break;
                case "Test":
                    totalItems = new TestDao().GetByUser(new UserDao().GetByLogin(User.Identity.Name)).Count;
                    break;
            }
            ViewBag.Controler = controler;

            return totalItems;
        }
    }
}