﻿using System;
using System.Web.Mvc;
using System.Web.Security;
using DataAccess.Dao;
using DataAccess.Model;
using PRIPO_v02.Class;

namespace PRIPO_v02.Areas.Student.Controllers
{
    [Authorize]
    public class UserController : Controller
    {
        public ActionResult Detail()
        {
            User user = new UserDao().GetByLogin(User.Identity.Name);

            if (Request.IsAjaxRequest())
            {
                return PartialView(user);
            }

            return View(user);
        }

        public ActionResult Edit()
        {

            User user = new UserDao().GetByLogin(User.Identity.Name);

            return View("Edit", user);
        }

        public ActionResult EditPassword()
        {

            User user = new UserDao().GetByLogin(User.Identity.Name);

            return View("EditPassword", user);
        }

        [HttpPost]
        public ActionResult Update(User user)
        {
            if (ModelState.IsValid)
            {
                UserDao userDao = new UserDao();

                User userOld = userDao.GetById(user.Id);

                user.Role = new RoleDao().GetById(userOld.Role.Id);

                if (userDao.GetByLogin(user.Login) != null && user.Login != userOld.Login)
                {
                    TempData["message-error"] = "Uživatelské jméno " + user.Login + " již je v databázi";

                    return View("Edit", user);
                }
                userDao.Merge(user);
                TempData["message-success"] = "Váš účet byl úspěšně upraven";
            }
            else
            {
                return View("Edit", user);
            }
            return View("Detail", user);
        }

        [HttpPost]
        public ActionResult UpdatePassword(User user)
        {
            if (ModelState.IsValid)
            {

                UserDao userDao = new UserDao();

                User userOld = userDao.GetById(user.Id);

                user.Role = new RoleDao().GetById(userOld.Role.Id);

                if (PasswordHash.ValidatePassword(user.CurrentPassword, userOld.Password))
                {
                    user.Password = PasswordHash.CreateHash(user.ConfirmPassword);
                    userDao.Merge(user);
                    TempData["message-success"] = "Heslo bylo úspěšně změněno";
                }
                else
                {
                    TempData["message-error"] = "Heslo nesouhlasí";
                    return RedirectToAction("EditPassword", "User", new { id = user.Id });
                }
                userDao.Merge(user);
                TempData["message-success"] = "Heslo bylo úspěšně změněno";
            }
            else
            {
                return View("EditPassword", user);
            }
            return View("Detail", user);

        }

        public ActionResult DeactivateAcount()
        {
            if (!ModelState.IsValid) return RedirectToAction("Index", "Home");

            UserDao userDao = new UserDao();

            User user = userDao.GetByLogin(User.Identity.Name);

            user.State = 2;

            user.RegistrationDate = DateTime.Now;

            userDao.Merge(user);
            TempData["message-success"] = "Váš uživatelský účet " + user.Name + " " + user.Surname + " byl úspěšně deaktivován";

            FormsAuthentication.SignOut();
            Session.Clear();

            return RedirectToAction("Index", "Home", new { area = "" });

        }

    }
}
