﻿using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;

namespace PRIPO_v02.Class
{
    public static class HtmlHelperExtensions
    {
        public static string IsSelected(this HtmlHelper html, string controllers = "", string actions = "",
            string pages = "", string cssClass = "active")
        {
            ViewContext viewContext = html.ViewContext;
            bool isChildAction = viewContext.Controller.ControllerContext.IsChildAction;

            if (isChildAction)
                viewContext = html.ViewContext.ParentActionViewContext;

            RouteValueDictionary routeValues = viewContext.RouteData.Values;
            string currentAction = routeValues["action"].ToString();
            string currentController = routeValues["controller"].ToString();
            string currentPage = HttpContext.Current.Request.Url.Query;


            if (string.IsNullOrEmpty(actions))
                actions = currentAction;

            if (string.IsNullOrEmpty(controllers))
                controllers = currentController;

            if (string.IsNullOrEmpty(pages))
                pages = currentPage;

            string[] acceptedActions = actions.Trim().Split(',').Distinct().ToArray();
            string[] acceptedControllers = controllers.Trim().Split(',').Distinct().ToArray();
            string[] acceptedPages = pages.Trim().Split(',').Distinct().ToArray();

            return acceptedActions.Contains(currentAction) && acceptedControllers.Contains(currentController) &&
                   acceptedPages.Contains(currentPage)
                ? cssClass
                : string.Empty;
        }
    }
}