﻿using System.Web.Mvc;
using System.Web.Security;
using DataAccess.Dao;
using DataAccess.Model;

namespace PRIPO_v02.Controllers
{
    public class LoginController : Controller
    {
        // GET: Admin/Login
        public ActionResult Index()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }

            return View();
        }

        [HttpPost]
        public ActionResult SignIn(string login, string password)
        {
            User user = new UserDao().GetByLogin(login);

            if (Membership.ValidateUser(login, password))
            {

                // null,0 - Nepotvrzený
                // 1 - Potvrzený
                // 2 - Zrušený
                switch (user.State)
                {
                    case 1:
                        FormsAuthentication.SignOut();
                        Session.Clear();

                        FormsAuthentication.SetAuthCookie(login, false);

                        TempData["message-success"] = "Přilášení k účtu " + user.Role.RoleDescription + " proběhlo úspěšně";

                        switch (user.Role.Identificator)
                        {
                            case "admin":
                                return RedirectToAction("Index", "Home", new { area = "Admin" });
                            case "teacher":
                                return RedirectToAction("Index", "Home", new { area = "Teacher" });
                            case "student":
                                return RedirectToAction("Index", "Home", new { area = "Student" });
                        }
                        break;
                    case 2:
                        TempData["message-error"] = "Váš účet byl zrušen";
                        return RedirectToAction("Index", "Login");
                    default:
                        TempData["message-error"] = "Váš účet stále nebyl aktivován. Obraťte se prosím na svého vyučujícího.";
                        return RedirectToAction("Index", "Login");
                }
            }
            TempData["message-error"] = "Login nebo heslo není správné";
            return RedirectToAction("Index", "Login");

        }

        public ActionResult LogOut()
        {
            FormsAuthentication.SignOut();
            Session.Clear();

            TempData["message-success"] = "Odhlášení proběhlo úspěšně";
            return RedirectToAction("Index", "Home", new { area = "" });
        }
    }
}