﻿using System;
using System.Web.Mvc;
using DataAccess.Dao;
using DataAccess.Model;
using PRIPO_v02.Class;

namespace PRIPO_v02.Controllers
{
    public class RegistrationController : Controller
    {
        // GET: Registration
        public ActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public ActionResult Add(User user)
        {
            if (ModelState.IsValid)
            {
                if (user.Password != Request.Form["ConfirmPassword"]) return RedirectToAction("Index", "Home");
                UserDao userDao = new UserDao();
                RoleDao roleDao = new RoleDao();
                Role role = roleDao.GetById(3);

                user.Role = role;

                user.State = 3;

                user.RegistrationDate = DateTime.Now;

                if (!user.Email.Contains("@uhk.cz"))
                {
                    TempData["message-error"] = "zadaný email " + user.Email + " není z domény uhk.cz";

                    return View("Create", user);
                }
                if (userDao.GetByEmail(user.Email) != null)
                {
                    TempData["message-error"] = "zadaný email " + user.Email + " již byl použit";

                    return View("Create", user);
                }

                if (userDao.GetByLogin(user.Login) != null)
                {
                    TempData["message-error"] = "uživatelské jméno " + user.Login + " již je v databázi";

                    return View("Create", user);
                }
                user.Password = PasswordHash.CreateHash(Request.Form["ConfirmPassword"]);
                userDao.Create(user);
                TempData["message-success"] = "Účet byl úspěšně vytvořen. Vyčkejte do aktivace účtu vyučujícím.";

            }

            else
            {
                return View("Create", user);
            }

            return RedirectToAction("Index", "Home");
        }
    }
}